#include "stdafx.h"
#include ".\outputavi.h"

OutputAvi::OutputAvi(char* filename, int width, int height, DWORD length, DWORD rate, DWORD scale, COMPVARS* CompVars,int bmilength,BITMAPINFOHEADER* bmi)
{
	aviout = new AVIOutputFile();
	aviout->initOutputStreams();

	memset(&aviout->videoOut->streamInfo, 0, sizeof(aviout->videoOut->streamInfo));

	aviout->videoOut->streamInfo.fccType = streamtypeVIDEO;
	aviout->videoOut->streamInfo.fccHandler	= CompVars->fccHandler;
	aviout->videoOut->streamInfo.dwQuality	= CompVars->lQ;
	aviout->videoOut->streamInfo.dwScale = scale;
	aviout->videoOut->streamInfo.dwRate = rate;
	aviout->videoOut->streamInfo.dwLength = length;
	aviout->videoOut->streamInfo.dwSuggestedBufferSize	= 0;

	aviout->videoOut->streamInfo.rcFrame.left	= 0;
	aviout->videoOut->streamInfo.rcFrame.top	= 0;
	aviout->videoOut->streamInfo.rcFrame.right	= width;
	aviout->videoOut->streamInfo.rcFrame.bottom	= height;

	aviout->videoOut->setCompressed(TRUE);

	aviout->videoOut->allocFormat(bmilength);
	memset(aviout->videoOut->getFormat(), 0, bmilength);
	memcpy(aviout->videoOut->getFormat(), bmi, bmilength);
	
	aviout->init(filename, width, height,
		TRUE, FALSE, FALSE, 10*(1024*1024), FALSE);
}
OutputAvi::~OutputAvi(void)
{
/*	AVI_close(outFile);*/
	aviout->finalize();
	
	delete aviout;
}


void OutputAvi::writeData(void* data, int dataSize, bool keyframe)
{
	aviout->videoOut->write(keyframe? AVIIF_KEYFRAME : 0, (char *)data, dataSize, 1);
/*	AVI_write_frame(outFile,(char*)data,dataSize,keyframe);*/
}


