#pragma once
#include "outputformat.h"

#ifdef _MSC_VER
#include <windows.h>      // for min/max
#endif // _MSC_VER
#include <string.h>
#include <iostream>

#include "StdIOCallback.h"

#include "EbmlHead.h"
#include "EbmlSubHead.h"
#include "EbmlVoid.h"
#include "FileKax.h"
#include "KaxSegment.h"
#include "KaxTracks.h"
#include "KaxTrackEntryData.h"
#include "KaxTrackAudio.h"
#include "KaxTrackVideo.h"
#include "KaxCluster.h"
#include "KaxClusterData.h"
#include "KaxBlock.h"
#include "KaxBlockData.h"
#include "KaxSeekHead.h"
#include "KaxCues.h"
#include "KaxInfo.h"
#include "KaxInfoData.h"

using namespace LIBMATROSKA_NAMESPACE;
using namespace std;

const uint64  TIMECODE_SCALE = 1000000; 
const bool bWriteDefaultValues = false;

// linked list of encoded frames
struct FrameList
{
    FrameList* next;
    bool keyframe;
	uint64 timecode;
    DWORD dataSize;
	DataBuffer* dataBuffer;
    binary* data;
};

class OutputMatroska :
	public OutputFormat
{
public:
	void writeData(void* data, int dataSize, bool keyframe);
	OutputMatroska(char* Filename, int width, int height, DWORD length, DWORD rate, DWORD scale, int bmilength,BITMAPINFOHEADER* bmi);
	~OutputMatroska(void);
	void addToBuffer(void* data, int dataSize, bool keyframe);
	void flushCluster();
private:

	uint64 CurrentTimeCode;
	uint64 frameTime;
	uint64 ClusterSize;
	uint64 lastClusterTime;
	KaxSeekHead MetaSeek;
	uint32 InfoSize;
	KaxCluster* CurrentCluster;
	KaxCues Cues;
	KaxSegment FileSegment;
	StdIOCallback* out_file;
	KaxTrackEntry* MyTrack1;
	EbmlVoid Dummy;
	uint64 SegmentSize;
	uint64 TrackSize;
	uint32 MetaSeekSize;
	// start and end of the list
	FrameList* frameListStart;
	FrameList* frameListEnd;
};
