#include "stdafx.h"
#include "xvid.h"
#include "math.h"

char xvidstats[MAX_PATH];

void CopyStats(char* fromFile, char* toFile, int stopPoint)
{

    FILE* from = fopen(fromFile,"rb");
    if (from != NULL)
    {
        int version;
        fread(&version,sizeof(version),1,from);
        FILE* to = fopen(toFile,"a+b");
        fseek(to,0,SEEK_END);
        if (ftell(to)==0 )
        {
            fwrite(&version,sizeof(version),1,to);
        }
        XvidStats frameInfo;
		char debug[255];
		sprintf(debug,"currentPos %d endpos %d",(ftell(to)-4)/sizeof(frameInfo), stopPoint);
		OutputDebugString(debug);
		for(int currentPos=(ftell(to)-4)/sizeof(frameInfo);
            (currentPos < stopPoint);
            currentPos++)
        {
			if (feof(from)) 
			{
				OutputDebugString("end of file");
			}
            fread(&frameInfo,sizeof(frameInfo),1,from);
            fwrite(&frameInfo,sizeof(frameInfo),1,to);
        }
        fclose(from);
        fclose(to);
    }

}

void CutStats(char* fromFile, char* toFile, int startPoint)
{
    FILE* from = fopen(fromFile,"rb");
    FILE* to = fopen(toFile,"wb");
    int version;
    fread(&version,sizeof(version),1,from);
    fwrite(&version,sizeof(version),1,to);
    XvidStats frameInfo;
    fseek(from,(startPoint+1)*sizeof(frameInfo)+4,SEEK_SET);
    while (!feof(from))
    {
        fread(&frameInfo,sizeof(frameInfo),1,from);
        fwrite(&frameInfo,sizeof(frameInfo),1,to);

    }
    fclose(from);
    fclose(to);

}

void XvidResumePreEncode(COMPVARS* CompVars,BOOL Resuming, DWORD ResumePoint,DWORD outputSize)
{
	OutputDebugString("\npre encode\n");
	// check for xvid
    if (mmioFOURCC( 'x','v','i','d') == CompVars->fccHandler)
    {
        XvidConfig* xvidState = (XvidConfig*)malloc(ICGetStateSize(CompVars->hic));
        ICGetState(CompVars->hic, xvidState, ICGetStateSize(CompVars->hic));
        switch (xvidState->mode)
        {
            case XVID_FIRSTPASS:
                if (Resuming)
                {
                    CopyStats("resume.stats",xvidState->statsfile,ResumePoint);
                }
                strcpy(xvidstats,xvidState->statsfile);
                if (!Resuming)
                {
                    DeleteFile(xvidState->statsfile);
                }
                strcpy(xvidState->statsfile,"resume.stats");
                break;
            case XVID_SECONDPASSINT:
                strcpy(xvidstats,xvidState->statsfile);
                if (Resuming)
                {
                    xvidState->filesize -=  outputSize/1024;
                    CutStats(xvidState->statsfile,"resume.stats",ResumePoint);
                    strcpy(xvidState->statsfile,"resume.stats");
                }
                break;
        }

        ICSetState(CompVars->hic, xvidState, ICGetStateSize(CompVars->hic));
        free(xvidState);
    } 
}

void XvidResumeFinishEncode(COMPVARS* CompVars, DWORD EndPoint, BOOL Resuming)
{
	char debugbuffer[255];
	sprintf(debugbuffer,"\nfinish encode %d\n",EndPoint);
	OutputDebugString(debugbuffer);
	// check for xvid
    if (mmioFOURCC( 'x','v','i','d') == CompVars->fccHandler)
    {
        XvidConfig* xvidState = (XvidConfig*)malloc(ICGetStateSize(CompVars->hic));
        ICGetState(CompVars->hic, xvidState, ICGetStateSize(CompVars->hic));
        switch (xvidState->mode)
        {
            case XVID_FIRSTPASS:
				if (!Resuming) DeleteFile("resume.stats");
                CopyStats("resume.stats",xvidstats,EndPoint);
                DeleteFile("resume.stats");
                break;
        }
        free(xvidState);
    } 
}


void XvidRestore(COMPVARS* CompVars) {
	OutputDebugString("\nrestore ");
	OutputDebugString(xvidstats);
	OutputDebugString("\n");
        XvidConfig* xvidState = (XvidConfig*)malloc(ICGetStateSize(CompVars->hic));
        ICGetState(CompVars->hic, xvidState, ICGetStateSize(CompVars->hic));
        strcpy(xvidState->statsfile,xvidstats);
        ICSetState(CompVars->hic, xvidState, ICGetStateSize(CompVars->hic));
        free(xvidState);

}
